#include <fstream>
#include <string>

#include <Magick++.h>

#include "charmap.h"

// argv[1]: charmap input file name (default: benchmark.pxl)
// argv[2]: bitmap output file name (default: benchmark.bmp)
//
int main(int argc, char** argv)
{
   std::string infilename = "benchmark.pxl";
   std::string outfilename = "benchmark.bmp";
   if(argc > 1) infilename = argv[1];
   if(argc > 2) outfilename = argv[2];
   
   // charmap input
   //
   std::ifstream pixistrm(infilename);
   if(!pixistrm) return EXIT_FAILURE;
   diskgraphics::Charmap cm;
   pixistrm >> cm;
   if(32 >= cm.get_sizex()) cm.out(&std::cout, true);
   pixistrm.close();
   
   Magick::InitializeMagick(*argv);
   Magick::Image img(Magick::Geometry(cm.get_sizex(), cm.get_sizey()), "white"); 
   img.magick("BMP");
   img.monochrome();
   img.type(Magick::BilevelType);
   
   for(int x = 0; x < cm.get_sizex(); x++)
      for(int y = 0; y < cm.get_sizey(); y++)
         img.pixelColor(x, y, Magick::Color(cm.get_pixel(x, y) == 0? "black": "white"));
   img.quantize(2);
   img.write(outfilename);
}
